Index: src/main/java/mk/ukim/finki/db/library/service/impl/BookServiceImpl.java
===================================================================
--- src/main/java/mk/ukim/finki/db/library/service/impl/BookServiceImpl.java	(revision 6791e8943b1679187be4017d2a0a7a9356c9b6a4)
+++ src/main/java/mk/ukim/finki/db/library/service/impl/BookServiceImpl.java	(revision e3bb1d4fa77ce5f90ff0044877a3a21e268c1216)
@@ -2,16 +2,14 @@
 
 import mk.ukim.finki.db.library.model.*;
-import mk.ukim.finki.db.library.model.exception.InvalidArgumentsException;
 import mk.ukim.finki.db.library.model.exception.InvalidBookIdException;
-import mk.ukim.finki.db.library.model.exception.LibraryNotFoundException;
 import mk.ukim.finki.db.library.repository.BookRepository;
 import mk.ukim.finki.db.library.repository.GenreRepository;
-import mk.ukim.finki.db.library.repository.LibraryRepository;
 import mk.ukim.finki.db.library.repository.WriterRepository;
 import mk.ukim.finki.db.library.service.BookService;
+import mk.ukim.finki.db.library.service.LibraryService;
 import org.springframework.stereotype.Service;
 
 import java.util.List;
-import java.util.Optional;
+import java.util.stream.Collectors;
 
 @Service
@@ -21,11 +19,9 @@
     private final WriterRepository writerRepository;
     private final GenreRepository genreRepository;
-    private final LibraryRepository libraryRepository;
 
-    public BookServiceImpl(BookRepository bookRepository, WriterRepository writerRepository, GenreRepository genreRepository, LibraryRepository libraryRepository) {
+    public BookServiceImpl(BookRepository bookRepository, WriterRepository writerRepository, GenreRepository genreRepository, LibraryService libraryService) {
         this.bookRepository = bookRepository;
         this.writerRepository = writerRepository;
         this.genreRepository = genreRepository;
-        this.libraryRepository = libraryRepository;
     }
 
@@ -41,13 +37,14 @@
 
     @Override
-    public Book create(Long id, String bookName, int bookNumber, boolean isFree, int bookPrice, int bookPriceLate) { //, List<Long> genreIds, List<Long> writerIds
+    public Book create(String bookName, int bookNumber, boolean isFree, int bookPrice, int bookPriceLate,
+                       BookGenre bookGenre, LibrariesEnum librariesEnum) { //, List<Long> genreIds, List<Long> writerIds
         //List<Genre> genres = this.genreRepository.findAllById(genreIds);
         //List<Writer> writers = this.writerRepository.findAllById(writerIds);
-        Book book = new Book(id, bookName, bookNumber, isFree, bookPrice, bookPriceLate); //, genres, writers
+        Book book = new Book(bookName, bookNumber, isFree, bookPrice, bookPriceLate, bookGenre, librariesEnum); //, genres, writers
         return this.bookRepository.save(book);
     }
 
     @Override
-    public Book update(Long id, String bookName, int bookNumber, boolean isFree, int bookPrice, int bookPriceLate, List<Long> genreIds, List<Long> writerIds, Long libraryId) {
+    public Book update(Long id, String bookName, int bookNumber, boolean isFree, int bookPrice, int bookPriceLate, List<Long> genreIds, List<Long> writerIds) {
         Book book =  this.findById(id);
         book.setBookName(bookName);
@@ -63,7 +60,4 @@
         book.setWriters(writers);
 
-        Library library = this.libraryRepository.findById(libraryId).orElseThrow(() -> new LibraryNotFoundException(libraryId));
-        book.setLibrary(library);
-
         return this.bookRepository.save(book);
     }
@@ -76,34 +70,7 @@
     }
 
-    @Override
-    public Book createB(Long id, String bookName, int bookNumber, boolean isFree, int bookPrice, int bookPriceLate, List<Long> genreIds, List<Long> writerIds, Long libraryId) {
-        List<Genre> genres = this.genreRepository.findAllById(genreIds);
-        List<Writer> writers = this.writerRepository.findAllById(genreIds);
-
-        Book book = new Book();
-        book.setId(id);
-        book.setBookName(bookName);
-        book.setBookNumber(bookNumber);
-        book.setFree(isFree);
-        book.setBookPrice(bookPrice);
-        book.setBookPriceLate(bookPriceLate);
-        book.setGenre((Genre) genres);
-        book.setWriters(writers);
-
-        //book = new Book(bookName, bookNumber, isFree, bookPrice, bookPriceLate, genreIds, writerIds, libraryId);
-        return null;
-    }
-
-    @Override
-    public List<Book> findByBookName(String bookName) {
-        if(bookName == null || bookName.isEmpty()){
-            throw new InvalidArgumentsException();
-        }
-
-        return this.bookRepository.findByBookName(bookName);
-    }
 
     //in bookRepository
-    //TODO: listBooksByNameAndGenre, listBooksByNameAndGenreAndWriter, listBooksByNameAndWriter
+    //TODO: listBooksByName, listBooksByNameAndGenre, listBooksByNameAndGenreAndWriter, listBooksByNameAndWriter
     //TODO: listBooksByGenre, listBooksByWriter
 }
Index: src/main/java/mk/ukim/finki/db/library/service/impl/GenreServiceImpl.java
===================================================================
--- src/main/java/mk/ukim/finki/db/library/service/impl/GenreServiceImpl.java	(revision 6791e8943b1679187be4017d2a0a7a9356c9b6a4)
+++ src/main/java/mk/ukim/finki/db/library/service/impl/GenreServiceImpl.java	(revision e3bb1d4fa77ce5f90ff0044877a3a21e268c1216)
@@ -29,6 +29,6 @@
 
     @Override
-    public Genre create(Long id, String name) {
-        Genre genre = new Genre(id, name);
+    public Genre create(String name) {
+        Genre genre = new Genre(name);
         return this.genreRepository.save(genre);
     }
Index: src/main/java/mk/ukim/finki/db/library/service/impl/LibraryServiceImpl.java
===================================================================
--- src/main/java/mk/ukim/finki/db/library/service/impl/LibraryServiceImpl.java	(revision 6791e8943b1679187be4017d2a0a7a9356c9b6a4)
+++ src/main/java/mk/ukim/finki/db/library/service/impl/LibraryServiceImpl.java	(revision e3bb1d4fa77ce5f90ff0044877a3a21e268c1216)
@@ -25,6 +25,6 @@
 
     @Override
-    public Library create(Long id, String libraryName, String libraryCity) {
-        Library library = new Library(id, libraryName, libraryCity);
+    public Library create(String libraryName, String libraryCity) {
+        Library library = new Library(libraryName, libraryCity);
         return this.libraryRepository.save(library);
     }
Index: src/main/java/mk/ukim/finki/db/library/service/impl/MembershipTypeServiceImpl.java
===================================================================
--- src/main/java/mk/ukim/finki/db/library/service/impl/MembershipTypeServiceImpl.java	(revision 6791e8943b1679187be4017d2a0a7a9356c9b6a4)
+++ src/main/java/mk/ukim/finki/db/library/service/impl/MembershipTypeServiceImpl.java	(revision e3bb1d4fa77ce5f90ff0044877a3a21e268c1216)
@@ -30,6 +30,6 @@
 
     @Override
-    public MembershipType create(Long id, String name) {
-        MembershipType membershipType = new MembershipType(id, name);
+    public MembershipType create(String name) {
+        MembershipType membershipType = new MembershipType(name);
         return this.membershipTypeRepository.save(membershipType);
     }
Index: src/main/java/mk/ukim/finki/db/library/service/impl/PriceListServiceImpl.java
===================================================================
--- src/main/java/mk/ukim/finki/db/library/service/impl/PriceListServiceImpl.java	(revision 6791e8943b1679187be4017d2a0a7a9356c9b6a4)
+++ src/main/java/mk/ukim/finki/db/library/service/impl/PriceListServiceImpl.java	(revision e3bb1d4fa77ce5f90ff0044877a3a21e268c1216)
@@ -29,6 +29,6 @@
 
     @Override
-    public PriceList create(Long id, int price) {
-        PriceList priceList = new PriceList(id, price);
+    public PriceList create(int price) {
+        PriceList priceList = new PriceList(price);
         return this.priceListRepository.save(priceList);
     }
Index: src/main/java/mk/ukim/finki/db/library/service/impl/ReservationBookServiceImpl.java
===================================================================
--- src/main/java/mk/ukim/finki/db/library/service/impl/ReservationBookServiceImpl.java	(revision 6791e8943b1679187be4017d2a0a7a9356c9b6a4)
+++ src/main/java/mk/ukim/finki/db/library/service/impl/ReservationBookServiceImpl.java	(revision e3bb1d4fa77ce5f90ff0044877a3a21e268c1216)
@@ -2,9 +2,8 @@
 
 import mk.ukim.finki.db.library.model.*;
-import mk.ukim.finki.db.library.model.exception.MemberNotFoundException;
+import mk.ukim.finki.db.library.model.exception.InvalidReservationBookIdException;
 import mk.ukim.finki.db.library.repository.BookRepository;
 import mk.ukim.finki.db.library.repository.MemberRepository;
 import mk.ukim.finki.db.library.repository.ReservationBookRepository;
-import mk.ukim.finki.db.library.repository.UserRepository;
 import mk.ukim.finki.db.library.service.ReservationBookService;
 import org.springframework.stereotype.Service;
@@ -17,11 +16,17 @@
 
     private final ReservationBookRepository reservationBookRepository;
-    private final UserRepository userRepository;
+    private final MemberRepository memberRepository;
     private final BookRepository bookRepository;
 
     public ReservationBookServiceImpl(ReservationBookRepository reservationBookRepository, MemberRepository memberRepository, BookRepository bookRepository) {
         this.reservationBookRepository = reservationBookRepository;
-        this.userRepository = memberRepository;
+        this.memberRepository = memberRepository;
         this.bookRepository = bookRepository;
+    }
+
+
+    @Override
+    public ReservationBook findById(Long id) {
+        return this.reservationBookRepository.findById(id).orElseThrow(InvalidReservationBookIdException::new);
     }
 
@@ -32,24 +37,12 @@
 
     @Override
-    public ReservationBook reserveBook(Long bookId, Date takeDate, Date returnDate) {
+    public ReservationBook reserveBook(Long memberId, Long bookId, Date takeDate, Date returnDate, boolean isReservedBook) {
+        Person member = memberId!=null ? this.memberRepository.findById(memberId).orElse((Member) null) : null;
+        Book book = bookId!=null ? this.bookRepository.findById(bookId).orElse((Book) null) : null;
 
-
-        ReservationBook reservationBook = new ReservationBook(takeDate, returnDate); //bookId,
+        ReservationBook reservationBook = new ReservationBook((Member) member, book, takeDate, returnDate, isReservedBook);
+        //TODO: treba da se zemat site izdanija od knigata, da se proveri dali ima slobodna i ako ima, od vkupnoto da se namali za edno
 
         return this.reservationBookRepository.save(reservationBook);
     }
-
-
-
-//    @Override
-//    public ReservationBook reserveBook(Long memberId, Long bookId, Date takeDate, Date returnDate, boolean isReservedBook) {
-//        Person member = memberId!=null ? this.userRepository.findById(memberId).orElse((Member) null) : null;
-//        Book book = bookId!=null ? this.bookRepository.findById(bookId).orElse((Book) null) : null;
-//
-//        ReservationBook reservationBook = new ReservationBook((Member) member, book, takeDate, returnDate, isReservedBook);
-//        //TODO: treba da se zemat site izdanija od knigata, da se proveri dali ima slobodna i ako ima, od vkupnoto da se namali za edno
-//
-//        return this.reservationBookRepository.save(reservationBook);
-//    }
-
 }
Index: src/main/java/mk/ukim/finki/db/library/service/impl/RoomServiceImpl.java
===================================================================
--- src/main/java/mk/ukim/finki/db/library/service/impl/RoomServiceImpl.java	(revision 6791e8943b1679187be4017d2a0a7a9356c9b6a4)
+++ src/main/java/mk/ukim/finki/db/library/service/impl/RoomServiceImpl.java	(revision e3bb1d4fa77ce5f90ff0044877a3a21e268c1216)
@@ -1,7 +1,5 @@
 package mk.ukim.finki.db.library.service.impl;
 
-import mk.ukim.finki.db.library.model.Book;
 import mk.ukim.finki.db.library.model.Room;
-import mk.ukim.finki.db.library.model.exception.InvalidArgumentsException;
 import mk.ukim.finki.db.library.model.exception.InvalidRoomIdException;
 import mk.ukim.finki.db.library.repository.RoomRepository;
@@ -31,16 +29,7 @@
 
     @Override
-    public Room create(Long id, String name, int places, int freePlaces) {
-        Room room = new Room(id, name, places, freePlaces);
-        return this.roomRepository.save(room);
-    }
-
-    @Override
-    public List<Room> findByName(String name) {
-        if(name == null || name.isEmpty()){
-            throw new InvalidArgumentsException();
-        }
-
-        return this.roomRepository.findByName(name);
+    public Room create(int room) {
+        Room roomNum = new Room(room);
+        return this.roomRepository.save(roomNum);
     }
 }
Index: src/main/java/mk/ukim/finki/db/library/service/impl/SchoolTypeServiceImpl.java
===================================================================
--- src/main/java/mk/ukim/finki/db/library/service/impl/SchoolTypeServiceImpl.java	(revision 6791e8943b1679187be4017d2a0a7a9356c9b6a4)
+++ src/main/java/mk/ukim/finki/db/library/service/impl/SchoolTypeServiceImpl.java	(revision e3bb1d4fa77ce5f90ff0044877a3a21e268c1216)
@@ -29,6 +29,6 @@
 
     @Override
-    public SchoolType create(Long id, String name) {
-        SchoolType schoolType = new SchoolType(id, name);
+    public SchoolType create(String name) {
+        SchoolType schoolType = new SchoolType(name);
         return this.schoolTypeRepository.save(schoolType);
     }
Index: src/main/java/mk/ukim/finki/db/library/service/impl/UserServiceImpl.java
===================================================================
--- src/main/java/mk/ukim/finki/db/library/service/impl/UserServiceImpl.java	(revision 6791e8943b1679187be4017d2a0a7a9356c9b6a4)
+++ src/main/java/mk/ukim/finki/db/library/service/impl/UserServiceImpl.java	(revision e3bb1d4fa77ce5f90ff0044877a3a21e268c1216)
@@ -2,4 +2,5 @@
 
 import mk.ukim.finki.db.library.model.Person;
+import mk.ukim.finki.db.library.model.exception.InvalidArgumentsException;
 import mk.ukim.finki.db.library.model.exception.InvalidUserCredentialsException;
 import mk.ukim.finki.db.library.model.exception.InvalidUsernameOrPasswordException;
@@ -9,6 +10,5 @@
 import org.springframework.stereotype.Service;
 
-import java.util.List;
-
+import java.util.Date;
 
 @Service
@@ -17,13 +17,13 @@
     private final UserRepository userRepository;
 
-    public UserServiceImpl(MemberRepository userRepository) {
+    public UserServiceImpl(UserRepository userRepository) {
         this.userRepository = userRepository;
     }
 
     @Override
-    public Person register(String name, String surname, String address, String town, String phoneNumber,
-                           String email, String password) { //SchoolType schoolType, MembershipType membershipType,
+    public Person register(String name, String surname, Date birthDate, String address, String town, String phoneNumber,
+                            String email, String password) { //SchoolType schoolType, MembershipType membershipType,
 
-        Person member = new Person(name, surname, address, town, phoneNumber, email, password);
+        Person member = new Person(name, surname, birthDate, address, town, phoneNumber, email, password);
 
         return this.userRepository.save(member);
@@ -37,8 +37,3 @@
         return userRepository.findByEmailAndPassword(email, password).orElseThrow(InvalidUserCredentialsException::new);
     }
-
-    @Override
-    public List<Person> findByEmail(String email) {
-        return this.userRepository.findByEmail(email);
-    }
 }
Index: src/main/java/mk/ukim/finki/db/library/service/impl/WriterServiceImpl.java
===================================================================
--- src/main/java/mk/ukim/finki/db/library/service/impl/WriterServiceImpl.java	(revision 6791e8943b1679187be4017d2a0a7a9356c9b6a4)
+++ src/main/java/mk/ukim/finki/db/library/service/impl/WriterServiceImpl.java	(revision e3bb1d4fa77ce5f90ff0044877a3a21e268c1216)
@@ -30,6 +30,6 @@
 
     @Override
-    public Writer create(Long id, String name) {
-        Writer writer = new Writer(id, name);
+    public Writer create(String name) {
+        Writer writer = new Writer(name);
         return this.writerRepository.save(writer);
     }
Index: src/main/java/mk/ukim/finki/db/library/web/BookController.java
===================================================================
--- src/main/java/mk/ukim/finki/db/library/web/BookController.java	(revision 6791e8943b1679187be4017d2a0a7a9356c9b6a4)
+++ src/main/java/mk/ukim/finki/db/library/web/BookController.java	(revision e3bb1d4fa77ce5f90ff0044877a3a21e268c1216)
@@ -1,68 +1,17 @@
 package mk.ukim.finki.db.library.web;
 
-import mk.ukim.finki.db.library.model.Book;
-import mk.ukim.finki.db.library.model.Genre;
-import mk.ukim.finki.db.library.model.Library;
-import mk.ukim.finki.db.library.model.Writer;
 import mk.ukim.finki.db.library.service.BookService;
-import mk.ukim.finki.db.library.service.GenreService;
-import mk.ukim.finki.db.library.service.LibraryService;
-import mk.ukim.finki.db.library.service.WriterService;
 import org.springframework.stereotype.Controller;
-import org.springframework.ui.Model;
-import org.springframework.web.bind.annotation.GetMapping;
 import org.springframework.web.bind.annotation.RequestMapping;
-import org.springframework.web.bind.annotation.RequestParam;
-
-import java.util.List;
 
 @Controller
-@RequestMapping("/book")
+@RequestMapping("/books")
 public class BookController {
 
     private final BookService bookService;
-    private final WriterService writerService;
-    private final GenreService genreService;
-    private final LibraryService libraryService;
 
-    public BookController(BookService bookService, WriterService writerService, GenreService genreService, LibraryService libraryService) {
+    public BookController(BookService bookService) {
         this.bookService = bookService;
-        this.writerService = writerService;
-        this.genreService = genreService;
-        this.libraryService = libraryService;
     }
 
-    //List<Long> genreIds, List<Long> writerIds, Long libraryId
-    //will show all books that are available in a library
-    @GetMapping
-    public String showBooks(@RequestParam(required = false) String bookName,
-                            Model model){
-
-        List<Book> books;
-//        List<Writer> writers;
-        //List<Genre> genres;
-        //List<Library> libraries;
-
-        if(bookName == null){
-            books = this.bookService.listAllBooks();
-//            writers = this.writerService.listAll();
-           // genres = this.genreService.listAll();
-
-        } else {
-            books = this.bookService.findByBookName(bookName);
-//            writers = this.writerService.listAll();
-//            genres = this.genreService.listAll();
-        }
-
-        model.addAttribute("books", books);
-//        model.addAttribute("writers", writers);
-//        model.addAttribute("genres", genres);
-        //model.addAttribute("libraries", libraries);
-
-        return "book.html";
-    }
-
-
-
-
 }
Index: src/main/java/mk/ukim/finki/db/library/web/LoginController.java
===================================================================
--- src/main/java/mk/ukim/finki/db/library/web/LoginController.java	(revision 6791e8943b1679187be4017d2a0a7a9356c9b6a4)
+++ src/main/java/mk/ukim/finki/db/library/web/LoginController.java	(revision e3bb1d4fa77ce5f90ff0044877a3a21e268c1216)
@@ -35,5 +35,5 @@
                     request.getParameter("password"));
             request.getSession().setAttribute("username", member);
-            return "redirect:/book";
+            return "redirect:/home";
         }
         catch (InvalidUserCredentialsException exception) {
Index: src/main/java/mk/ukim/finki/db/library/web/RegisterController.java
===================================================================
--- src/main/java/mk/ukim/finki/db/library/web/RegisterController.java	(revision 6791e8943b1679187be4017d2a0a7a9356c9b6a4)
+++ src/main/java/mk/ukim/finki/db/library/web/RegisterController.java	(revision e3bb1d4fa77ce5f90ff0044877a3a21e268c1216)
@@ -35,4 +35,5 @@
     public String register(@RequestParam String name,
                            @RequestParam String surname,
+                           @RequestParam Date birthDate,
                            @RequestParam String town,
                            @RequestParam String address,
@@ -40,7 +41,7 @@
                            @RequestParam String email,
                            @RequestParam String password
-    ) {
+                           ) {
         try{
-            this.userService.register(name, surname, town, address, phoneNumber, email, password);
+            this.userService.register(name, surname, birthDate, town, address, phoneNumber, email, password);
             return "redirect:/login";
         } catch (InvalidArgumentsException | PasswordsDoNotMatchException exception) {
Index: src/main/java/mk/ukim/finki/db/library/web/ReservationBookController.java
===================================================================
--- src/main/java/mk/ukim/finki/db/library/web/ReservationBookController.java	(revision 6791e8943b1679187be4017d2a0a7a9356c9b6a4)
+++ src/main/java/mk/ukim/finki/db/library/web/ReservationBookController.java	(revision e3bb1d4fa77ce5f90ff0044877a3a21e268c1216)
@@ -1,51 +1,9 @@
 package mk.ukim.finki.db.library.web;
 
-import mk.ukim.finki.db.library.model.exception.InvalidArgumentsException;
-import mk.ukim.finki.db.library.model.exception.PasswordsDoNotMatchException;
-import mk.ukim.finki.db.library.service.ReservationBookService;
 import org.springframework.stereotype.Controller;
-import org.springframework.ui.Model;
-import org.springframework.web.bind.annotation.*;
-
-import java.util.Date;
+import org.springframework.web.bind.annotation.RequestMapping;
 
 @Controller
-@RequestMapping("/resBook")
+@RequestMapping("/reservationBook")
 public class ReservationBookController {
-
-    private final ReservationBookService reservationBookService;
-
-    public ReservationBookController(ReservationBookService reservationBookService) {
-        this.reservationBookService = reservationBookService;
-    }
-
-    @GetMapping("/resBook")
-    public String showRes(){
-        return "resBook";
-    }
-
-    @GetMapping
-    public String getReservationBook(@RequestParam(required = false) String error, Model model) {
-        if(error != null && !error.isEmpty()) {
-            model.addAttribute("hasError", true);
-            model.addAttribute("error", error);
-        }
-        //ReservationBook reservationBook = this.reservationBookService.getCurrentUserId(id);
-        model.addAttribute("books", this.reservationBookService.listAll());
-        return "resBook";
-    }
-
-    @PostMapping("/reserve/{id}")
-    public String reserve(@PathVariable Long id,
-                            @RequestParam Date takeDate,
-                           @RequestParam Date returnDate
-    ) {
-        try{
-            this.reservationBookService.reserveBook(id, takeDate, returnDate);
-            return "redirect:/book";
-        } catch (InvalidArgumentsException | PasswordsDoNotMatchException exception) {
-            return "redirect:/resBook?error=" + exception.getMessage();
-        }
-    }
-
 }
